* Author(s).....:Greg Neid
* Copyright.....:1996-2000, Gold River CareHomes Inc.


*This program is used to send email automatically from any routine
*The data is passed in the form:
*	do emailsnd with "to","copy","bcc","subject","message","attachment","html"
*	if "to" = "elist", an array aNames is filled from elist.dbf and all addresses in elist are processed
*

Parameters to, copy, bcc, subject, message, attachment, html


#define Alltrim(s)		ltrim(trim(s))

#define SEE_MIN_RESPONSE_WAIT  1
#define SEE_MAX_RESPONSE_WAIT  2
#define SEE_CONNECT_WAIT       3
#define SEE_DISABLE_MIME       4
#define SEE_MIN_LINE_WAIT      5
#define SEE_MAX_LINE_WAIT      6
#define SEE_QUOTED_PRINTABLE   8
#define SEE_AUTO_DRIVER_CALL   9
#define SEE_LOG_FILE          20

#define SEE_GET_ERROR_TEXT     1
#define SEE_GET_COUNTER        2
#define SEE_GET_RESPONSE       3
#define SEE_GET_SOCK_ERROR     4

#define SEE_GET_MESSAGE_BYTES_READ  10
#define SEE_GET_ATTACH_BYTES_READ   11
#define SEE_GET_TOTAL_BYTES_READ    12
#define SEE_GET_MESSAGE_BYTES_SENT  13
#define SEE_GET_ATTACH_BYTES_SENT   14
#define SEE_GET_TOTAL_BYTES_SENT    15
#define SEE_GET_VERSION             16

#define SEE_GET_MSG_COUNT           17
#define SEE_GET_MSG_SIZE            18
#define SEE_GET_BUFFER_COUNT        19
#define SEE_GET_CONNECT_STATUS      20
#define SEE_GET_REGISTRATION        21
#define SEE_GET_ATTACH_COUNT        22
#define SEE_GET_LAST_RESPONSE       23
#define SEE_GET_VERIFY_STATUS       24
#define SEE_GET_SERVER_IP           25
#define SEE_GET_BUILD               26
#define SEE_KEY_CODE                0


local f, nI
f = new emailsendFORM()


USE PROFILE.DBF in select()

select profile
SET FIELDS TO SMTPADDR, EMAILSEND, RESPWMIN, RESPWMAX, LINEWMIN, LINEWMAX, CONNWAIT, ;
              CREAT_DATE, MOD_DATE, MOD_TIME

f.server.value                 = profile->smtpaddr
f.from.value                   = profile->emailsend
f.esee_min_response_wait.value = profile->respwmin
f.esee_max_response_wait.value = profile->respwmax
f.esee_min_line_wait.value     = profile->linewmin
f.esee_max_line_wait.value     = profile->linewmax
f.esee_connect_wait.value      = profile->connwait
use

if empty(to) .or. type("to") # "C"
   msgdlg("Invalid email address","E-Mailing System","OK","SYSTEM")
   return
endif

if empty(copy)
   copy = Null
endif

if empty(bcc)
   bcc = Null
endif

if empty(subject)
   subject = " "
endif

if empty(message)
   message = " "
endif

if empty(attachment)
   attachement = Null
endif

if lower(to) = "elist"
   set deleted on
   use elist in select()
   select elist
   SET FIELDS TO NAME, EMAIL
   nI = 1
   do while .not. eof("elist")
      if f.aNames.Size / 2 < nI   && grow array if necessary
         f.aNames.Grow(1)
      endif
      f.aNames[nI,1] = alltrim(elist->name)+"<"+alltrim(elist->email)+">"
      f.aNames[nI,2] = .t.
      skip 1 in elist
      nI = nI + 1
   enddo
   use
*   f.to.value = "aNames"
else
   f.aNames[1,1] = "<"+alltrim(to)+">"
endif

if empty(html)    && check if html message
   html = ""
endif

if lower(html) = "html"
   f.bHtml.value              = .t.
endif



f.copy.value                  = copy
f.bcc.value                   = bcc
f.subject.value               = subject
f.message.value               = message
f.attachment.value            = attachment

f.ReadModal()
f.release()


** END HEADER -- do not remove this line*
* Generated on 1999/03/01
*

CLASS emailsendFORM OF FORM
   this.OnOpen     = CLASS::EMAILFORMONOPEN
   this.Text       = "Email Send"
   this.Width      = 50
   this.Height     = 15
   this.mdi        = .f.
   this.sysmenu    = .f.
   this.EscExit    = .f.
   this.TopMost    = .t.
   this.aNames     = new array(1,2)	&& array containing send names

   do grGetAppUnits	 && calculate and set _app.height, _app.width
   this.top  = _app.height - this.height - 3
   this.left = _app.width -  this.width  - 1

   DEFINE browseentryfield ProceedAfterError OF THIS;
       PROPERTY; 
         Value .f.,;
         visible .f.

   DEFINE browseentryfield bHtml OF THIS;
       PROPERTY; 
         Value .f.,;
         visible .f.

   DEFINE browseentryfield server OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield from OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield esee_min_response_wait OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield esee_max_response_wait OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield esee_min_line_wait OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield esee_max_line_wait OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield esee_connect_wait OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield copy OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield bcc OF THIS;
       PROPERTY; 
         Value chr(0),;
         visible .f.

   DEFINE browseentryfield subject OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield message OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

   DEFINE browseentryfield attachment OF THIS;
       PROPERTY; 
         Value "",;
         visible .f.

**********************************************************
   DEFINE grLabel textxx OF THIS;
       PROPERTY; 
         Left 13,;
         Width 20,;
         Value "Email System Version",;
         Top 1

   DEFINE grLabel textbuild OF THIS;
       PROPERTY; 
         Left 13,;
         Width 20,;
         Value "Email System Build",;
         Top 2

   DEFINE grLabel seeVersion OF THIS;
       PROPERTY; 
         Left 35,;
         Width 6,;
         FontBold .F.,;
         Height 1,;
         Value 0,;
         Top 1

   DEFINE grLabel seeBuild OF THIS;
       PROPERTY; 
         Left 35,;
         Width 6,;
         FontBold .F.,;
         Height 1,;
         Value 0,;
         Top 2

   DEFINE grLabel STARTParam OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Started Timing Parameters",;
         Top 3

   DEFINE grLabel STARTParamTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 3

   DEFINE PushButton ParamOK OF THIS;
       PROPERTY; 
         Left 1,;
         Width 4,;
         Height 1.25,;
         text "",;
         colornormal "btntext/btnface",;
         enabled .f.,;
         Top 3.875

   DEFINE grLabel COMPLETEParam OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Completed Timing Parameters",;
         Top 4

   DEFINE grLabel COMPLETEParamTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 4

   DEFINE grLabel STARTCONNECT OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Started SMTP Connect",;
         Top 5

   DEFINE grLabel STARTCONNECTTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 5

   DEFINE PushButton ConnectOK OF THIS;
       PROPERTY; 
         Left 1,;
         Width 4,;
         Height 1.25,;
         text "",;
         colornormal "btntext/btnface",;
         enabled .f.,;
         Top 5.875

   DEFINE grLabel COMPLETECONNECT OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Completed SMTP Connect",;
         Top 6

   DEFINE grLabel COMPLETECONNECTTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 6

   DEFINE grLabel STARTSEND OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Started Email Send",;
         Top 7

   DEFINE grLabel STARTSENDTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 7

   DEFINE PushButton SendOK OF THIS;
       PROPERTY; 
         Left 1,;
         Width 4,;
         Height 1.25,;
         text "",;
         enabled .f.,;
         Top 7.875

   DEFINE grLabel COMPLETESEND OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Completed Email Send",;
         Top 8

   DEFINE grLabel COMPLETESENDTIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 8

   DEFINE grLabel STARTCLOSE OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Started SMTP Close",;
         Top 9

   DEFINE grLabel STARTCLOSETIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 9

   DEFINE PushButton CloseOK OF THIS;
       PROPERTY; 
         Left 1,;
         Width 4,;
         Height 1.25,;
         text "",;
         enabled .f.,;
         Top 9.875

   DEFINE grLabel COMPLETECLOSE OF THIS;
       PROPERTY; 
         Left 6,;
         Width 30,;
         FontBold .F.,;
         Height 1,;
         Value "Completed SMTP Close",;
         Top 10

   DEFINE grLabel COMPLETECLOSETIME OF THIS;
       PROPERTY; 
         Left 40,;
         Width 10,;
         FontBold .F.,;
         Height 1,;
         Value "",;
         Top 10

   DEFINE grLabel MsgSize OF THIS;
       PROPERTY; 
         Left 5,;
         visible .f.,;
         Value 0,;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel AttachSize OF THIS;
       PROPERTY; 
         Left 5,;
         visible .f.,;
         Value 0,;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel TotalSize OF THIS;
       PROPERTY; 
         Left 5,;
         visible .f.,;
         Value 0,;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel BytesSentText OF THIS;
       PROPERTY; 
         Left 5,;
         Value "Bytes Sent",;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel BytesSent OF THIS;
       PROPERTY; 
         Left 15,;
         Value 0,;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel SendElapsedTime OF THIS;
       PROPERTY; 
         Left 25,;
         visible .f.,;
         Value 0,;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel BytesPerSecond OF THIS;
       PROPERTY; 
         Left 30,;
         Value 0,;
         Width 7,;
         FontBold .F.,;
         picture "9,999.9",;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE grLabel BytesPerSecondText OF THIS;
       PROPERTY; 
         Left 38,;
         Value "kb/second",;
         Width 10,;
         FontBold .F.,;
         colornormal "B+/BtnFace",;
         Height 1,;
         Top 11

   DEFINE RECTANGLE RECTANGLE1 OF THIS;
       PROPERTY; 
         BorderStyle 1,;
         Text "Rectangle1",;
         FontBold .F.,;
         Left .9,;
         Top 12,;
         ColorNormal "0xffff80/0xffff80",;
         Height 2,;
         Width 48.2

   DEFINE RECTANGLE pComplete OF THIS;
       PROPERTY; 
         BorderStyle 1,;
         Text "Rectangle1",;
         FontBold .F.,;
         Left 1,;
         Top 12.3,;
         ColorNormal "B+/B+",;
         Height 1.4,;
         Width 0

   DEFINE grLabel PercentComplete OF THIS;
       PROPERTY; 
         Left 23,;
         Value " ",;
         Width 5,;
         FontBold .t.,;
         ColorNormal "B+/0xffff80",;
         Height 1,;
         Top 12.6

   DEFINE grLabel ERRORTEXT OF THIS;
       PROPERTY; 
         Left 6,;
         Value "No Errors",;
         Width 46,;
         FontBold .F.,;
         Height 1,;
         Top 14


   PROCEDURE EmailFormOnOpen
      form.cSMTPError = "NO"
      class::LoadSeeDll()
      class::InitSee()
      class::ConnectISP()
      class::SendMessage()
      class::CloseSee()
      if form.cSMTPError = "YES"      && error during send
         form.print()
      endif
      form.close()
      
      
   PROCEDURE LoadSeeDll
      form.SeeDLL = "SEE16.DLL"
      cSeeDLL = form.SeeDLL
      if type("seeAttach") # "FP"
         EXTERN CINT seeAttach(CLONG,CLONG) &cSeeDLL.
      endif
      if type("seeClose") # "FP"
         EXTERN CINT  seeClose(CLONG) &cSeeDLL.
      endif
      if type("seeDebug") # "FP"
         EXTERN CINT  seeDebug(CLONG,CINT,CSTRING,CINT) &cSeeDLL.
      endif
      if type("seeDecodeBuffer") # "FP"
         EXTERN CINT  seeDecodeBuffer(CSTRING,CSTRING,CINT) &cSeeDLL.
      endif
      if type("seeDeleteEmail") # "FP"
         EXTERN CINT  seeDeleteEmail(CLONG,CLONG) &cSeeDLL.
      endif
      if type("seeDriver") # "FP"
         EXTERN CINT  seeDriver(CLONG) &cSeeDLL.
      endif
      if type("seeEncodeBuffer") # "FP"
         EXTERN CINT  seeEncodeBuffer(CSTRING,CSTRING,CINT) &cSeeDLL.
      endif
      if type("seeErrorText") # "FP"
         EXTERN CINT  seeErrorText(CLONG,CLONG,CSTRING,CLONG) &cSeeDLL.
      endif
      if type("seeExtractText") # "FP"
         EXTERN CINT  seeExtractText(CSTRING,CSTRING,CSTRING,CINT) &cSeeDLL.
      endif
      if type("seeGetEmailCount") # "FP"
         EXTERN CINT  seeGetEmailCount(CLONG) &cSeeDLL.
      endif
      if type("seeGetEmailFile") # "FP"
         EXTERN CINT  seeGetEmailFile(CLONG,CLONG,CSTRING,CSTRING,CSTRING) &cSeeDLL.
      endif
      if type("seeGetEmailLines") # "FP"
         EXTERN CINT  seeGetEmailLines(CLONG,CLONG,CLONG,CSTRING,CLONG) &cSeeDLL. && may be wrong??
      endif
      if type("seeEmailSize") # "FP"
         EXTERN CINT  seeGetEmailSize(CLONG,CLONG) &cSeeDLL.
      endif
      if type("seeEmailUID") # "FP"
         EXTERN CINT  seeGetEmailUID(CLONG,CLONG,CSTRING,CLONG) &cSeeDLL.  && may be wrong?
      endif
      if type("seeIntegerParam") # "FP"
         EXTERN CLONG  seeIntegerParam(CINT,CINT,CLONG) &cSeeDLL.
      endif
      if type("seePop3Connect") # "FP"
         EXTERN CINT  seePop3Connect(CLONG,CSTRING,CSTRING,CSTRING) &cSeeDLL.
      endif
      if type("seeRelease") # "FP"
         EXTERN CINT  seeRelease() &cSeeDLL.
      endif
      if type("seeSendEmail") # "FP"
         EXTERN CINT  seeSendEmail(CLONG,CSTRING,CSTRING,CSTRING,CSTRING,CSTRING,CSTRING) &cSeeDLL.
      endif
      if type("seeSmtpConnect") # "FP"
         EXTERN CINT  seeSmtpConnect(CLONG,CSTRING,CSTRING,CSTRING) &cSeeDLL.
      endif
      if type("seeStatistics") # "FP"
         EXTERN CLONG  seeStatistics(CLONG,CLONG) &cSeeDLL.
      endif
      if type("seeStringParam") # "FP"
         EXTERN CINT  seeStringParam(CLONG,CLONG,CSTRING) &cSeeDLL.
      endif
      if type("seeVerifyFormat") # "FP"
         EXTERN CINT  seeVerifyFormat(CSTRING) &cSeeDLL.
      endif
      if type("seeVerifyUser") # "FP"
         EXTERN CINT  seeVerifyUser(CLONG,CSTRING) &cSeeDLL.
      endif
   
   PROCEDURE InitSee

      form.seeOperation = "seeAttach"

      form.seeCode   = SeeAttach(1,see_Key_Code)     && requires code for access
      if form.seeCode < 0
         form.cSMTPError = "YES"
         class::SMTPErrorDisplay()
         form.seeCode = 0
      endif

      form.seeVersion.value = seeStatistics(0,SEE_GET_VERSION)
      form.seeBuild.value   = seeStatistics(0, SEE_GET_BUILD)
      form.seeVersion.value = alltrim(itoh(form.seeVersion.value))
      cX = form.seeVersion.value
      form.seeVersion.value = left(cX,1) + "." + substr(cX,2,1) + "." + right(cX,1)
      form.seeBuild.value   = alltrim(str(form.seeBuild.value))
      
   
****  Set up line and connect timing  *****************

   
      form.StartParamTime.value = Time()
      
      form.seeOperation = "seeIntegerParam"

      if form.esee_min_response_wait.value > 0
         form.seeCode   = seeIntegerParam(0,see_min_response_wait,form.esee_min_response_wait.value)
         if form.seeCode < 0
            form.cSMTPError = "YES"
            class::SMTPErrorDisplay()
            form.seeCode = 0
         endif
      endif

      if form.esee_max_response_wait.value > 0
         form.seeCode   = seeIntegerParam(0,see_max_response_wait,form.esee_max_response_wait.value)
         if form.seeCode < 0
            form.cSMTPError = "YES"
            class::SMTPErrorDisplay()
            form.seeCode = 0
         endif
      endif

      if form.esee_min_line_wait.value > 0
         form.seeCode   = seeIntegerParam(0,see_min_line_wait,form.esee_min_line_wait.value)
         if form.seeCode < 0
            form.cSMTPError = "YES"
            class::SMTPErrorDisplay()
            form.seeCode = 0
         endif
      endif

      if form.esee_max_line_wait.value > 0
         form.seeCode   = seeIntegerParam(0,see_max_line_wait,form.esee_max_line_wait.value)
         if form.seeCode < 0
            form.cSMTPError = "YES"
            class::SMTPErrorDisplay()
            form.seeCode = 0
         endif
      endif
      
      if form.esee_connect_wait.value > 0
         form.seeCode   = seeIntegerParam(0,see_connect_wait,form.esee_connect_wait.value)
         if form.seeCode < 0
            form.cSMTPError = "YES"
            class::SMTPErrorDisplay()
            form.seeCode = 0
         endif
      endif

      if form.cSMTPError = "YES"
         form.ParamOk.upbitmap = "Resource #28 resource.dll"
      else
         form.ParamOk.upbitmap = "Resource #20 resource.dll"
      endif
   
      form.CompleteParamTime.value = Time()





****  Set up parameters  ******************************
      form.from.value   = "<"+alltrim(form.from.value)+">"
      form.server.value = alltrim(form.server.value)
      if empty(alltrim(form.copy.value))
         form.copy.value = null
      else
         form.copy.value = alltrim(form.copy.value)
      endif
      form.subject.value = alltrim(form.subject.value)
      form.message.value = alltrim(form.message.value)
      if empty(form.attachment.value)
         form.attachment.value = null
      else
         form.attachment.value = alltrim(form.attachment.value)
      endif
      

   PROCEDURE ConnectISP
      form.StartConnectTime.value = Time()
      
      form.seeOperation = "seeSmtpConnect"
      form.seeCode   = seeSmtpConnect(0, form.server.value,form.from.value,Null)

                              && there is s problem with timeout, so we try twice
      if form.seeCode  = -46  && check for connect error and try again
         sleep 10             && wait ten seconds before trying again
         form.seeCode   = seeSmtpConnect(0, form.server.value,form.from.value,Null)
      endif
      
      
      if form.seeCode < 0
         form.cSMTPError = "YES"
         class::SMTPErrorDisplay()
         form.seeCode = 0
         form.ConnectOk.upbitmap = "Resource #28 resource.dll"
      else
         form.ConnectOk.upbitmap = "Resource #20 resource.dll"
      endif
   
      form.CompleteConnectTime.value = Time()
   
   PROCEDURE SendMessage
      form.seeOperation = "seeSendEmail"
      local cSendList
      cSendList = ""
      for nI = 1 to form.aNames.size/2
         cSendList = cSendList + ", " + form.aNames[nI,1]
      next nI
      cSendList = alltrim(right(cSendList,len(cSendList)-1))   && remove first comma and space
      
      if form.cSMTPError # "YES"
         form.StartSendTime.value = Time()
         sleep 1	&& allow form to display
         if form.bHtml.value
            form.seeCode   = seeIntegerParam(0,SEE_QUOTED_PRINTABLE, 2)      &&html code
         else
            form.seeCode   = seeIntegerParam(0,SEE_QUOTED_PRINTABLE, 0)      && text only
         endif
         form.seeCode   = seeIntegerParam(0,SEE_AUTO_DRIVER_CALL,0)
         form.seeCode   = seeSendEmail(0,cSendList,form.copy.value,Null,form.Subject.value,form.Message.value,form.attachment.value)
      else
         form.StartSend.value = "Email Send not Started"
         form.StartSendTime.value = Time()
         form.SendOk.upbitmap = "Resource #28 resource.dll"
      endif
      
      if form.seeCode < 0
         class::SendError()
      endif
      
      form.MsgSize.value   =  len(form.Subject.value) + len(form.Message.value)
      if type("form.Attachment.value") = "C"
         aAttachment = new array(1,5)
         aAttachment.Dir(form.attachment.value,"")
         form.AttachSize.value = aAttachment[1,2]
      else
         form.AttachSize.value = 0
      endif
      form.TotalSize.value = form.MsgSize.value * 1.1 + form.AttachSize.value * 1.37   && estimate sending size
      
      cEndLoop = "xx"
      do while cEndLoop # "yy"  && a loop that waits for the send to finish
         form.seeCode = seeDriver(0)
         if form.seeCode < 0
            class::SendError()
            exit
         endif
         if form.seeCode = 0 
            exit
         endif
         form.BytesSent.value = seeStatistics(0, SEE_GET_TOTAL_BYTES_SENT)
         form.SendElapsedTime.value = elapsed(time(),form.StartSendTime.value)
         if form.SendElapsedTime.value > 1
            form.BytesPerSecond.value  = round(form.BytesSent.value/(form.SendElapsedTime.value*1000),2)
            form.pComplete.width = min(((form.BytesSent.value*96)/form.TotalSize.value)/2,48)
            form.PercentComplete.value = alltrim(str(form.BytesSent.value*100/form.TotalSize.value)+"%")
            form.pComplete.width = min(((form.BytesSent.value*96)/form.TotalSize.value)/2,48)
            form.PercentComplete.value = alltrim(str(form.BytesSent.value*100/form.TotalSize.value)+"%")
            if form.BytesSent.value/form.TotalSize.value > .49
               form.PercentComplete.Colornormal = "0xffff80/B+"
            endif
         endif
         loop
      enddo
      
      form.CompleteSendTime.value = Time()
      if form.cSMTPError # "YES"
         form.SendOk.upbitmap = "Resource #20 resource.dll"
      else
         form.SendOk.upbitmap = "Resource #28 resource.dll"
      endif
      
      sleep 1	&& allow form to display
      

   PROCEDURE SendError
      form.cSMTPError = "YES"
      form.SendOk.upbitmap = "Resource #28 resource.dll"
      class::SMTPErrorDisplay()
      form.seeCode = 0
   
   PROCEDURE CloseSee
      form.seeOperation = "seeClose"
      form.StartClose.value = "Started SMTP Close"
      form.StartCloseTime.value = Time()
      form.seeCode   = SeeClose(0)
      if form.seeCode < 0
         form.cSMTPError = "YES"
         class::SMTPErrorDisplay()
         form.seeCode = 0
      endif

      form.seeCode   = SeeRelease()
      if form.seeCode < 0
         form.cSMTPError = "YES"
         class::SMTPErrorDisplay()
         form.seeCode = 0
      endif
      
      form.CloseOk.upbitmap = "Resource #20 resource.dll"
      form.CompleteCloseTime.value = Time()
      form.refresh()
      
      cSeeDLL = form.SeeDLL
      release DLL &cSeeDLL
         
   
   PROCEDURE SMTPErrorDisplay
*      form.ErrorText.value = space(64)
*      length = seeErrorText(form.seeCode,form.Errortext.value,64)
*      form.ErrorText.value = rtrim(form.ErrorText.value)

      do case
         case form.seeCode = -1
            form.ErrorText.value = "-1: Socket has been closed."
         case form.seeCode = -4
            form.ErrorText.value = "-4: WINSOCK is currently blocking."
         case form.seeCode = -5
            form.ErrorText.value = "-5: Bad status flag passed to seeStatus."
         case form.seeCode = -7
            form.ErrorText.value = "-7: Invalid socket."
         case form.seeCode = -8
            form.ErrorText.value = "-8: Socket timed out."
         case form.seeCode = -9
            form.ErrorText.value = "-9: No available sockaddr structures."
         case form.seeCode = -12
            form.ErrorText.value = "-12: No host name."
         case form.seeCode = -14
            form.ErrorText.value = "-14: Internal checksum fails!"
         case form.seeCode = -18
            form.ErrorText.value = "-18: Cannot create socket."
         case form.seeCode = -31
            form.ErrorText.value = "-31: Response buffer has overflowed."
         case form.seeCode = -32
            form.ErrorText.value = "-32: Bad character in email address."
         case form.seeCode = -34
            form.ErrorText.value = "-34: Cannot access WINSOCK."
         case form.seeCode = -35
            form.ErrorText.value = "-35: Cannot open file."
         case form.seeCode = -36
            form.ErrorText.value = "-36: Error attempting to connect."
         case form.seeCode = -37
            form.ErrorText.value = "-37: EMPTY email address."
         case form.seeCode = -38
            form.ErrorText.value = "-38: FromPtr is NULL."
         case form.seeCode = -39
            form.ErrorText.value = "-39: Missing '@' character in email address."
         case form.seeCode = -40
            form.ErrorText.value = "-40: Missing FROM email address."
         case form.seeCode = -41
            form.ErrorText.value = "-41: Missing '<' delimiter in email address."
         case form.seeCode = -43
            form.ErrorText.value = "-43: Missing '>' terminating email address."
         case form.seeCode = -44
            form.ErrorText.value = "-44: Not connected to server."
         case form.seeCode = -45
            form.ErrorText.value = "-45: Must have at least one recipient."
         case form.seeCode = -46
            form.ErrorText.value = "-46: Cannot find SMTP/POP3 server."
         case form.seeCode = -47
            form.ErrorText.value = "-47: Unexpected NULL pointer."
         case form.seeCode = -48
            form.ErrorText.value = "-48: ToPtr is NULL."
         case form.seeCode = -49
            form.ErrorText.value = "-49: SMTP returned error."
         case form.seeCode = -50
            form.ErrorText.value = "-50: SMTP/POP3 server not specified."
         case form.seeCode = -51
            form.ErrorText.value = "-51: Socket read error."
         case form.seeCode = -52
            form.ErrorText.value = "-52: Socket write error."
         case form.seeCode = -53
            form.ErrorText.value = "-53: Too many '@' symbols in email address."
         case form.seeCode = -54
            form.ErrorText.value = "-54: Found unexpected '>' character in email address."
         case form.seeCode = -55
            form.ErrorText.value = "-55: Cannot allocate memory."
         case form.seeCode = -56
            form.ErrorText.value = "-56: Illegal chars in server name."
         case form.seeCode = -58
            form.ErrorText.value = "-58: SMTP function ONLY."
         case form.seeCode = -59
            form.ErrorText.value = "-59: POP3 function ONLY."
         case form.seeCode = -61
            form.ErrorText.value = "-61: USER name not specified."
         case form.seeCode = -62
            form.ErrorText.value = "-62: PASSWORD not specified."
         case form.seeCode = -63
            form.ErrorText.value = "-63: POP3 returned error."
         case form.seeCode = -64
            form.ErrorText.value = "-64: No such message number."
         case form.seeCode = -65
            form.ErrorText.value = "-65: Missing filename."
         case form.seeCode = -66
            form.ErrorText.value = "-66: Missing email path."
         case form.seeCode = -67
            form.ErrorText.value = "-67: Cannot create file."
         case form.seeCode = -68
            form.ErrorText.value = "-68: Buffer is NULL."
         case form.seeCode = -69
            form.ErrorText.value = "-69: Buffer size < 128."
         case form.seeCode = -70
            form.ErrorText.value = "-70: Missing path for attachments."
         case form.seeCode = -71
            form.ErrorText.value = "-71: seeAttach not called."
         case form.seeCode = -72
            form.ErrorText.value = "-72 seeAttach already called."
         case form.seeCode = -73
            form.ErrorText.value = "-73 Channel number of out range."
         case form.seeCode = -74
            form.ErrorText.value = "-74 Bad key code (2nd argument to seeAttach)."
         otherwise
            form.ErrorText.value = str(form.seeCode)+": This error is unknown to CMS."
      endcase

      EmailMsgDlg(form.ErrorText.value,"Error in "+form.seeOperation)
   

   ***
   *** WINSOCK Error Codes 
   ***
   
   *-10004: Interrupted system call.
   *-10009: Bad file number.
   *-10013: Access denied.
   *-10014: Bad address.
   *-10022: Invalid argument.
   *-10024: Too many open files.
   *-10035: Would block socket in non-blocking mode.
   *-10036: Blocking call already in progress.
   *-10037: Operation already completed.
   *-10038: Not a valid socket
   *-10039: Destination address required.
   *-10040: Message too big for buffer.
   *-10041: Prot mismatch.
   *-10042: Prot option invalid.
   *-10043: Prot not supported.
   *-10044: Socket type not supported.
   *-10045: Socket operation not supported.
   *-10047: Socket address family not supported.
   *-10048: Socket address already in use.
   *-10049: Socket address not available.
   *-10050: Network error.
   *-10051: Cannot reach network.
   *-10052: Connection dropped.
   *-10053: Connection timed-out or aborted.
   *-10054: Connection reset by remote host.
   *-10055: Out of buffer space.
   *-10056: Socket already connected.
   *-10057: Socket not connected.
   *-10058: Socket functionality shut down.
   *-10060: Timed-out attempting to connect.
   *-10061: Connection refused by remote host.
   *-10064: Host is down
   *-10065: No route to host
   *-10091: Network not yet ready.
   *-10092: WINSOCK doesn't support requested version.
   *-10093: Sockets not initialized. Call WSAStartup.
   *-11001: Host does not exist.
   *-11002: Host not found. Try again.
   *-11003: Non-recoverable error has occurred.
   *-11004: No data is available.
   
   ***
   *** SEE Error Codes.
   *    -1: Socket has been closed.
   *    -4: WINSOCK is currently blocking.
   *    -5: Bad status flag passed to seeStatus.
   *    -7: Invalid socket.
   *    -8: Socket timed out.
   *    -9: No available sockaddr structures.
   *   -12: No host name.
   *   -14: Internal checksum fails!
   *   -18: Cannot create socket.
   *   -31: Response buffer has overflowed.
   *   -32: Bad character in email address.
   *   -34: Cannot access WINSOCK
   *   -35: Cannot open file.
   *   -36: Error attempting to connect. 
   *   -37: EMPTY email address.
   *   -38: FromPtr is NULL.
   *   -39: Missing '@' character in email address.
   *   -40: Missing FROM email address.
   *   -41: Missing '<' delimiter in email address.
   *   -43: Missing '>' terminating email address.
   *   -44: Not connected to server
   *   -45: Must have at least one receipient.
   *   -46: Cannot find SMTP/POP3 server.
   *   -47: Unexpected NULL pointer.
   *   -48: ToPtr is NULL.
   *   -49: SMTP returned error. 
   *   -50: SMTP/POP3 server not specified.
   *   -51: Socket read error.
   *   -52: Socket write error.
   *   -53: Too many '@' symbols in email address.
   *   -54: Found unexpected '>' character in email address.
   *   -55: Cannot allocate memory.
   *   -56: Illegal chars in server name.
   *   -58: SMTP function ONLY.
   *   -59: POP3 function ONLY.
   *   -61: USER name not specified.
   *   -62: PASSWORD not specified.
   *   -63: POP3 returned error. 
   *   -64: No such message number.
   *   -65: Missing filename.
   *   -66: Missing email path.
   *   -67: Cannot create file.
   *   -68: Buffer is NULL.
   *   -69: Buffer size < 128.
   *   -70: Missing path for attachments.
   
ENDCLASS

PROCEDURE grGetAppUnits
*-----------------------------------------------------------------------
*-- Programmer..: Ken Chan (Zak) (CIS: 72662,1305)
*-- Date........: 08/15/1994
*-- Notes.......: Used to determine the application's height/width
*--               for use in centering dialog boxes.
*-- Written for.: dBASE 5.0 for Windows
*-- Rev. History: 04/22/1994 -- Original
*--               07/06/1994 -- Modified due to changes in dBASE/Win --
*--                             according to Zak, this should _always_
*--                             work, even if the internal units
*--                             change.
*--               08/15/1994 -- Even more changes by Zak -- removed
*--                             an unnecessary section, and such.
*-- Calls.......: ByteVal()      && below
*-- Called by...: Class: Dialog
*-- Usage.......: Do GetAppUnits
*-- Example.....: Do GetAppUnits
*-- Returns.....: None
*-- Parameters..: None
*-- Side Effects: Creates threee custom (useful) properties associated with
*--               _App:    _app.Width  = Width of screen in dBASE units
*--                        _app.Height = Height of screen in dBASE units
*--                        _app.THeight = Height of title bar in dBASE units
*--                        dBASE Units are actually called TURPINS (in case 
*--                        you wanted to know).
*--               These are very useful, because you can then center
*--               a form with:
*--               this.Top  = (_app.Height - this.Height) / 2
*--               this.Left = (_app.Width  - this.Width)  / 2
*-----------------------------------------------------------------------

  if type( "_app.Width" ) = "U"

     *-- Get screen width/height in pixels
     *-- Get screen width/height in pixels
     extern CINT GetSystemMetrics( CINT ) USER.EXE
     #define SM_CXSCREEN 0
     #define SM_CYSCREEN 1
     _app.XPixels = GetSystemMetrics( SM_CXSCREEN )
     _app.YPixels = GetSystemMetrics( SM_CYSCREEN )


     #define FORM_HEIGHT 4
     #define FORM_WIDTH  20
     define form fConfig ;
        property ;
           Text     "AutoConfig", ;
           Height   FORM_HEIGHT, ;
           Width    FORM_WIDTH, ;
           autocenter .f., ;
           visible  .f., ;
           MDI      .F., ;
           Sizeable .F., ;
           SysMenu  .F.,;
           Maximize .F.,;
           Minimize .F.

     fConfig.open()

     extern    CVOID   GetWindowRect ( CHANDLE, CPTR ) USER.EXE
     #define W_LEFT    1
     #define W_TOP     3
     #define W_RIGHT   5
     #define W_BOT     7
     cRect = space( 8 )
     GetWindowRect( fConfig.hWnd, cRect )
     nWinHeight = ByteVal( cRect, W_BOT,   2 ) - ByteVal( cRect, W_TOP,  2 )

     extern CVOID GetClientRect( CHANDLE, CPTR ) USER.EXE
     #define C_WIDTH   5
     #define C_HEIGHT  7
     cRect = space( 8 )
     GetClientRect( fConfig.hWnd, cRect )
     nClientWidth  = ByteVal( cRect, C_WIDTH,  2 )
     nClientHeight = ByteVal( cRect, C_HEIGHT, 2 )

     fConfig.close()

     _app.XUnits  = nClientWidth  / FORM_WIDTH
     _app.YUnits  = nClientHeight / FORM_HEIGHT
     _app.THeight = ( nWinHeight - nClientHeight ) / _app.YUnits

     *-- Calculate screen size in dBASE units (Turpins)
     _app.Width   = _app.XPixels / _app.XUnits
     _app.Height  = _app.YPixels / _app.YUnits
  
  endif

RETURN
*-- EoP: GetAppUnits


FUNCTION ByteVal(cArg, nPos, nLen)
*-----------------------------------------------------------------------
*-- Programmer..: Ken Chan (Zak) (CIS: 72662,1305)
*-- Date........: 08/15/1994
*-- Notes.......: Converts (multi-)byte value stored in a character
*--               string to its numeric value. Used primarily for
*--               interfacing with API.
*-- Written for.: dBASE 5.0 for Windows
*-- Rev. History: 07/06/1994 -- Original
*--               08/15/1994 -- Changed conversion algorithm to use
*--                             built-in BITx() functions. Set defaults
*--                             for arguments.
*-- Calls.......: None
*-- Called by...: GetAppUnits
*-- Usage.......: ByteVal(<cArg>,<nPos>,<nLen>)
*-- Example.....: ByteVal(cRect, 3, 2)
*-- Returns.....: Numeric
*-- Parameters..: cArg = character string containing value
*--               nPos = position in string where (multi-)byte value
*--                      starts
*--               nLen = length of value (maximum 4 [32 bits])
*-----------------------------------------------------------------------

   #define MAX_LEN 4             && maximum 32 bits

   if pcount() < 3
      nLen = min(MAX_LEN,len(cArg))
      if pcount() < 2
         nPos = 1
      endif
   endif
  
   local nRet, nPtr
   nRet = 0
   *-------------------------------------------------------------
   *-- Numbers are stored in little-endian format, with the low
   *-- byte first. The loop reads the characters backward,
   *-- starting at the high byte. Each iteration shifts the
   *-- previous total "up" one byte and "masts-in" the current
   *-- character's value.
   *-------------------------------------------------------------
   for nPtr = nPos +max( min( nLen, MAX_LEN),1) - 1 to nPos step - 1
       nRet = bitor( bitlshift( nRet, 8 ), asc( substr( cArg, nPtr, 1 )))
   endfor
 
   *-------------------------------------------------------------
   *-- The BITx() functions treat their arguments as 32-bit
   *-- numbers, with the high bit as a sign bit. If the result
   *-- of the previous loop is a negative number, that means
   *-- the high bit of a 32-bit number was set, so the number
   *-- must be converted to its unsigned 32-bit value.
   *-------------------------------------------------------------
   if nRet < 0
      nRet = 256 ^ MAX_LEN + nRet
   endif
 
RETURN nRet
*-- EoF: ByteVal()


FUNCTION EmailMsgDlg
*-----------------------------------------------------------------------
*-- Parameters..: cMsg       = Message text
*--               cTitle     = Title at top of dialog box
*--               cButtonSet = Buttons to display -- options are:
*--                            "OK"   (Ok)
*--                            "OC"   (Ok/Cancel)
*--                            "ARI"  (Abort/Retry/Ignore)
*--                            "YNC"  (Yes/No/Cancel)
*--                            "YN"   (Yes/No)
*--                            "RC"   (Retry/Cancel)
*--               cIcon      = Determines type of image to display
*--                            to left of cMsg.
*--                            "WARN"    -- gives red hand image
*--                            "CONFIRM" -- gives green question mark
*--                            "ALERT"   -- red exclamation point
*--                            "ALERT2"  -- yellow exclamation point
*--                            "INFO"    -- blue 'i'
*--                            "SYSTEM"  -- yellow lightning' plus sends email message to _app.CMS_SysManager
*--               nDefault   = Specifies the default button
*-----------------------------------------------------------------------
    
    parameters cMsg,cTitle,cButtonSet,cIcon,nDefault
    * yes, we'd like to use locals, but you can't TYPE() 'em.


    *-- Set defaults
    if type("CMSG") <> "C"
        cMsg = "No message!"
    endif
    if type("cTitle") <> "C"
        cTitle = ""
    endif
    if type("cButtonSet") <> "C"
        cButtonSet = "OK"
    endif
    if type("cIcon") <> "C"
        cIcon = "ALERT2"
    endif
    if type("nDefault") <> "N"
        nDefault = 1
    else
        nDefault = min(nDefault,len(cButtonSet))
    endif

    local fEamilMsgDlg
    fEmailMsgDlg = new EmailMsgDlg()                 && class defined below

    * dialog box title and message
    fEmailMsgDlg.Text = cTitle
    fEmailMsgDlg.ieMsgBox.value = cMsg

    * which bitmap to display?
    cIcon = upper(cIcon)
    do case
       case cIcon = "ALERT2"
           fEmailMsgDlg.iiIcon.DataSource = "filename grAlert.bmp"
       case cIcon = "ALERT"
           fEmailMsgDlg.iiIcon.DataSource = "filename grAlert.bmp"
       case cIcon = "CONFIRM"
           fEmailMsgDlg.iiIcon.DataSource = "filename grOk.bmp"
       case cIcon = "WARN"
           fEmailMsgDlg.iiIcon.DataSource = "filename grWarn.bmp"
       case cIcon = "INFO"
           fEmailMsgDlg.iiIcon.DataSource = "filename grInfo.bmp"
       case cIcon = "OK"
           fEmailMsgDlg.iiIcon.DataSource = "filename grOk.bmp"
       case cIcon = "QUESTION"
           fEmailMsgDlg.iiIcon.DataSource = "filename grQuest.bmp"
        case cIcon = "SYSTEM"
           fEmailMsgDlg.iiIcon.DataSource = "filename grSysRep.bmp"
           fEmailMsgDlg.systememail.value = .t.
       otherwise
           fEmailMsgDlg.iiIcon.DataSource = "filename grQuest.bmp"
    endcase

    *-- button location on form
    #define DIALOG_CENTERBUTTON_LEFT 27
    #define DIALOG_2BUTTONS_LEFT1    19
    #define DIALOG_2BUTTONS_LEFT2    35
    #define DIALOG_3BUTTONS_LEFT1    11
    #define DIALOG_3BUTTONS_LEFT3    43
    #define DIALOG_BUTTON_TOP        5

    *-- determine and define buttons based on cButtonSet
    cButtonSet = upper(cButtonSet)
    do case
       case cButtonSet = "YNC"                  && Yes/No/Cancel
           fEmailMsgDlg[1] = new YesButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_3BUTTONS_LEFT1
           fEmailMsgDlg[1].OnClick = {;form.close("YES")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[2] = new NoButton(fEmailMsgDlg,"2")
           fEmailMsgDlg[2].Left    = DIALOG_CENTERBUTTON_LEFT
           fEmailMsgDlg[2].OnClick = {;form.close("NO")}
           fEmailMsgDlg[2].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[3] = new PushButton(fEmailMsgDlg,"3")
           fEmailMsgDlg[3].Left    = DIALOG_3BUTTONS_LEFT3
           fEmailMsgDlg[3].Text    = "&Cancel"
           fEmailMsgDlg[3].OnClick = {;form.close("CANCEL")}
           fEmailMsgDlg[3].Top     = DIALOG_BUTTON_TOP
       case cButtonSet = "YN"                   && Yes/No
           fEmailMsgDlg[1] = new YesButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_2BUTTONS_LEFT1
           fEmailMsgDlg[1].OnClick = {;form.close("YES")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[2] = new NoButton(fEmailMsgDlg,"2")
           fEmailMsgDlg[2].Left    = DIALOG_2BUTTONS_LEFT2
           fEmailMsgDlg[2].OnClick = {;form.close("NO")}
           fEmailMsgDlg[2].Top     = DIALOG_BUTTON_TOP
        case cButtonSet = "OC"                  && Ok/Cancel
           fEmailMsgDlg[1] = new PushButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_2BUTTONS_LEFT1
           fEmailMsgDlg[1].Text    = "&OK"
           fEmailMsgDlg[1].OnClick = {;form.close("OK")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[2] = new PushButton(fEmailMsgDlg,"2")
           fEmailMsgDlg[2].Left    = DIALOG_2BUTTONS_LEFT2
           fEmailMsgDlg[2].Text    = "&Cancel"
           fEmailMsgDlg[2].OnClick = {;form.close("CANCEL")}
           fEmailMsgDlg[2].Top     = DIALOG_BUTTON_TOP
       case cButtonSet = "RC"                   && Retry/Cancel
           fEmailMsgDlg[1] = new RetryButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_2BUTTONS_LEFT1
           fEmailMsgDlg[1].OnClick = {;form.close("RETRY")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[2] = new PushButton(fEmailMsgDlg,"2")
           fEmailMsgDlg[2].Left    = DIALOG_2BUTTONS_LEFT2
           fEmailMsgDlg[2].Text    = "&Cancel"
           fEmailMsgDlg[2].OnClick = {;form.close("CANCEL")}
           fEmailMsgDlg[2].Top     = DIALOG_BUTTON_TOP
       case cButtonSet = "ARI"                  && Abort/Retry/Ignore
           fEmailMsgDlg[1] = new AbortButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_3BUTTONS_LEFT1
           fEmailMsgDlg[1].OnClick = {;form.close("ABORT")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[2] = new RetryButton(fEmailMsgDlg,"2")
           fEmailMsgDlg[2].Left    = DIALOG_CENTERBUTTON_LEFT
           fEmailMsgDlg[2].OnClick = {;form.close("RETRY")}
           fEmailMsgDlg[2].Top     = DIALOG_BUTTON_TOP
           fEmailMsgDlg[3] = new IgnoreButton(fEmailMsgDlg,"3")
           fEmailMsgDlg[3].Left    = DIALOG_3BUTTONS_LEFT3
           fEmailMsgDlg[3].OnClick = {;form.close("IGNORE")}
           fEmailMsgDlg[3].Top     = DIALOG_BUTTON_TOP
       otherwise                                && OK or other
                                                && buttonstype
           fEmailMsgDlg[1] = new PushButton(fEmailMsgDlg,"1")
           fEmailMsgDlg[1].Left    = DIALOG_CENTERBUTTON_LEFT
           fEmailMsgDlg[1].Text    = "&OK"
           fEmailMsgDlg[1].OnClick = {;form.close("OK")}
           fEmailMsgDlg[1].Top     = DIALOG_BUTTON_TOP
    endcase
    fEmailMsgDlg[nDefault].setfocus()   && set focus to default button

    private xRETURN     && can't TYPE() a local
    xRETURN = fEmailMsgDlg.readmodal()
    fEmailMsgDlg.release()
    
    return iif(type("xRETURN")="C",xRETURN,"")

CLASS EmailMsgDlg of Form
*-----------------------------------------------------------------------
*-- Programmer..: Bowen Moursund
*-- Date........: 08/07/94
*-- Notes.......: The base class for the MsgDlg() form. This class isn't
*--               in standard FD format - you'll lose stuff if it is
*--               loaded into the FD.
*-- Written for.: dBaseWin 5.0
*-- Rev. History: None
*-- Calls.......: GetAppUnits
*-- Called by...: MsgDlg()
*-----------------------------------------------------------------------

    this.Height      = 7.3
    this.Width       = 70
    this.Sizeable    = .F.
    this.Minimize    = .F.
    this.MDI         = .F.
    this.ColorNormal = "W"
    this.Sysmenu     = .f.
    this.Maximize    = .f.
    this.topmost     = .t.
    this.AutoCenter  = .f.
    this.OnOpen      = CLASS::EmailMsgdlgOnOpen

   do grGetAppUnits	 && calculate and set _app.height, _app.width
   this.top  = _app.height - this.height - 3
   this.left = _app.width -  this.width  - 1
        
    define image iiIcon of this;
      property;
        Left     0.86,;
        Height   5.45,;
        Width    17.86,;
        Top      0.75

    define rectangle irMsgBox of this;
      property;
        BorderStyle  2,;
        ColorNormal "N/W",;
        Text        "",;
        Height       3.8,;
        Left        20.50,;
        Width       47.00,;
        Top          0.70,;
        Border      .T.

   define editor ieMsgBox of this;
     property;
       FontSize    10.00,;
       FontBold    .F.,;
       ColorNormal "N/W",;
       Left        22.29,;
       Height       3.2,;
       Width       43.14,;
       Top          1.00,;
       Border      .F.,;
       Modify      .F.,;
       Wrap        .T.,;
       ScrollBar    0,;
       Enabled     .F.

   PROCEDURE EmailMsgdlgOnOpen
      
      
      
ENDCLASS
*-- EoClass: EamilMsgDlg
