
* Author(s).....: Greg Neid
*                 GARVIN LECLAIRE
* Copyright.....:1996-2000, Gold River CareHomes Inc.


#include "email.h"


*******************************************************************************
class PostButton(f,name) of PushButton(f,name) custom
*******************************************************************************
	this.upBitmap		= "Resource #2050 resource.dll"
	this.downBitmap		= "Resource #2051 resource.dll"
	this.Text		= "&Post"
        this.SpeedTip           = "Post the Changes Made"
	this.height		= BITMAPS_BUTTON_HEIGHT
	this.width		= BITMAPS_BUTTON_WIDTH

endclass

*******************************************************************************


*******************************************************************************
class EditButton(f,n) of PushButton(f,n) custom
*******************************************************************************

	this.Text		= "&Change"
	this.upBitmap		= "Resource #2090 resource.dll"
	this.downBitmap		= "Resource #2093 resource.dll"
        this.SpeedTip           = "Change Data"
	this.height		= BITMAPS_BUTTON_HEIGHT
	this.width		= BITMAPS_BUTTON_WIDTH

endclass

*******************************************************************************


*******************************************************************************
class DefaultPushButton(f,n) of PushButton(f,n) custom
*******************************************************************************

	this.Text		= ""
	this.height		= BITMAPS_BUTTON_HEIGHT
	this.width		= BITMAPS_BUTTON_WIDTH

endclass

*******************************************************************************

*******************************************************************************
class DefaultRadioButton(f,n) of RadioButton(f,n) custom
*******************************************************************************
	this.Group		= False
	this.Enabled		= False
	this.FontSize		= radb_FontSize
	this.FontName		= radb_FontName
	this.FontBold		= False
	this.FontItalic 	= radb_FontItalic
	this.FontStrikeOut	= radb_FontStrikeOut
	this.FontUnderline	= radb_FontUnderline
	this.Height		= 1.00


endclass

*******************************************************************************

*******************************************************************************
class DefaultRectangle(f,n) of Rectangle(f,n) custom
*******************************************************************************
	this.Border		= True
	this.BorderStyle	= BORDERSTYLE_NORMAL
*	this.BorderStyle	= BORDERSTYLE_RAISED
*	this.BorderStyle	= BORDERSTYLE_LOWERED
	this.FontBold		= bord_FontBold
	this.FontItalic 	= bord_FontItalic
	this.FontName		= bord_FontName
	this.FontSize		= bord_FontSize
	this.FontStrikeOut	= bord_FontStrikeOut
	this.FontUnderline	= bord_FontUnderline
	this.PatternStyle	= PATTERNSTYLE_SOLID
*	this.PatternStyle	= PATTERNSTYLE_BDIAGONAL
*	this.PatternStyle	= PATTERNSTYLE_CROSS
*	this.PatternStyle	= PATTERNSTYLE_DIAGCROSS
*	this.PatternStyle	= PATTERNSTYLE_FDIAGONAL
*	this.PatternStyle	= PATTERNSTYLE_HORIZONTAL
*	this.PatternStyle	= PATTERNSTYLE_VERTICAL


endclass

*******************************************************************************

*******************************************************************************
class NormalText(f,name) of Text(f,name) custom
*******************************************************************************
	this.Border		= False
	this.Bold		= False
	this.Height		= 1.00
	this.Width		= 60.00
	this.Left		= 0.00
	this.Top		= 0.00
	this.Alignment		= ALIGNMENT_TOP_LEFT
	this.FontBold		= text_FontBold
	this.FontItalic 	= text_FontItalic
	this.FontName		= text_FontName
	this.FontSize		= text_FontSize
	this.FontStrikeOut	= text_FontStrikeOut
	this.FontUnderline	= text_FontUnderline

endclass

*******************************************************************************
class grLabel(f,name) of entryfield(f,name) custom
*******************************************************************************
        this.when               = {;return false}
        this.tabstop            = False
        this.enabled            = False
	this.Border		= False
	this.Bold		= False
	this.Height		= 1.00
	this.Width		= 20.00
        this.colornormal        = "btntext/btnface"
	this.FontBold		= text_FontBold
	this.FontName		= text_FontName

endclass
*******************************************************************************
class NormalCenterText(f,name) of NormalText(f,name) custom
*******************************************************************************

	this.Alignment		= ALIGNMENT_CENTER

endclass

*******************************************************************************
class BoldCenterText(f,name) of BoldText(f,name) custom
*******************************************************************************

	this.Alignment		= ALIGNMENT_CENTER

endclass


*******************************************************************************
class BoldText(f,name) of NormalText(f,name) custom
*******************************************************************************

	this.Bold		= True

endclass

*******************************************************************************
class BrowseEntryField(f,name) of Entryfield(f,name) custom
*******************************************************************************
	this.Border		= False
	this.Enabled		= False
	this.FontBold		= efld_FontBold
	this.FontItalic 	= efld_FontItalic
	this.FontName		= efld_FontName
	this.FontSize		= efld_FontSize
	this.FontStrikeOut	= efld_FontStrikeOut
	this.FontUnderline	= efld_FontUnderline
	this.Height		= 1.00

endclass

*******************************************************************************
class BrowseNumericField(f,name) of Entryfield(f,name) custom
*******************************************************************************
	this.Border		= False
	this.Enabled		= False
	this.FontBold		= efld_FontBold
	this.FontItalic 	= efld_FontItalic
	this.FontName		= efld_FontName
	this.FontSize		= efld_FontSize
	this.FontStrikeOut	= efld_FontStrikeOut
	this.FontUnderline	= efld_FontUnderline
        this.width              = 9
        this.picture            = "999,999.99"
        this.function           = "J"
	this.Height		= 1.00

endclass

*******************************************************************************


*******************************************************************************
class BrowseCheckBox(f,name) of CheckBox(f,name) custom
*******************************************************************************
	this.Enabled		= False
	this.FontBold		= chbx_FontBold
	this.FontItalic 	= chbx_FontItalic
	this.FontName		= chbx_FontName
	this.FontSize		= chbx_FontSize
	this.FontStrikeOut	= chbx_FontStrikeOut
	this.FontUnderline	= chbx_FontUnderline
	this.Enabled		= False
	this.Height		= chbx_Height

endclass

*******************************************************************************
class BrowseEditor(f,name) of Editor(f,name) custom
*******************************************************************************
	this.Enabled		= False
	this.FontBold		= edit_FontBold
	this.FontItalic 	= edit_FontItalic
	this.FontName		= edit_FontName
	this.FontSize		= edit_FontSize
	this.FontStrikeOut	= edit_FontStrikeOut
	this.FontUnderline	= edit_FontUnderline
	this.Height		= 5
	this.Modify		= True
	this.Scrollbar		= SCROLLBAR_AUTO
	this.Width		= 15
	this.Wrap		= True

endclass

*******************************************************************************
class BrowseBrowseBox(f,name) of Browse(f,name) custom
*******************************************************************************
	this.Enabled		= True
	this.ShowDeleted	= False
	this.ShowRecNo		= False
	this.FontBold		= brow_FontBold
	this.FontItalic 	= brow_FontItalic
	this.FontName		= brow_FontName
	this.FontSize		= brow_FontSize
	this.FontStrikeOut	= brow_FontStrikeOut
	this.FontUnderline	= brow_FontUnderline
	this.Append		= False
	this.Delete		= False
	this.Follow		= False
	this.Modify		= False
	this.Toggle		= False

endclass

*******************************************************************************
class BrowseComboBox(f,name) of ComboBox(f,name) custom
*******************************************************************************
*	this.Style		= STYLE_DROPDOWN
	this.Style		= STYLE_DROPDOWN_LIST
	this.FontBold		= cbbx_FontBold
	this.FontItalic 	= cbbx_FontItalic
	this.FontName		= cbbx_FontName
	this.FontSize		= cbbx_FontSize
	this.FontStrikeOut	= cbbx_FontStrikeOut
	this.FontUnderline	= cbbx_FontUnderline
	this.Enabled		= False

endclass

*******************************************************************************
class DefaultListBox(f,name) of ListBox(f,name) custom
*******************************************************************************
	this.FontBold		= lbbx_FontBold
	this.FontItalic 	= lbbx_FontItalic
	this.FontName		= lbbx_FontName
	this.FontSize		= lbbx_FontSize
	this.FontUnderline	= lbbx_FontUnderline
	this.Enabled		= True
	this.Mutiple		= False

endclass

*******************************************************************************
class BrowseSpinBox(f,name) of SpinBox(f,name) custom
*******************************************************************************
	this.FontBold		= spbx_FontBold
	this.FontItalic 	= spbx_FontItalic
	this.FontName		= spbx_FontName
	this.FontSize		= spbx_FontSize
	this.FontStrikeOut	= spbx_FontStrikeOut
	this.FontUnderline	= spbx_FontUnderline
	this.Enabled		= False

endclass

*******************************************************************************
class BrowseTABBOX(f,name) of TABBOX(f,name) custom
*******************************************************************************
        this.ColorNormal        = "BtnFace"
	this.FontBold		= tabbx_FontBold
	this.FontItalic 	= tabbx_FontItalic
	this.FontName		= tabbx_FontName
	this.FontSize		= tabbx_FontSize
	this.FontUnderline	= tabbx_FontUnderline
        this.FontBold           = .F.
        this.OnSelChange        = {;form.PageNo = this.CurSel}
        this.ColorHighLight     = "BtnText/BtnFace"
        this.Height             = 1
endclass
 
 *******************************************************************************
